
		di
		lxi	h,4241h
		shld	4000h
		lxi	sp,0F000h
		mvi	a,11111100b	;---
		out	80h

		xra	a
		call	006Ah
		mvi	a,4Ah
		out	88h

		lxi	h,0
		lxi	d,24
		mvi	c,24
ClrScr:	mvi	b,40
ClrLine:	mvi	m,0
		inx	h
		dcr	b
		jnz	ClrLine
		dcr	c
		dad	d
		jnz	ClrScr

		lxi	h,Letterc
		lxi	d,00E18h
		lxi	b,8
		call	005Ch

		lxi	h,Letterj
		lxi	d,00E50h
		lxi	b,8
		call	005Ch

		lxi	h,Text1
		lxi	d,14+(7*64)
		call	PrintText

		lxi	h,Text2
		lxi	d,11+(9*64)
		call	PrintText

		lxi	h,Text3
		lxi	d,10+(11*64)
		call	PrintText

		lxi	h,Text4
		lxi	d,12+(12*64)
		call	PrintText

		lxi	h,Text5
		lxi	d,17+(14*64)
		call	PrintText

		lxi	h,Text6
		lxi	d,7+(17*64)
		call	PrintText

		lxi	h,Text7
		lxi	d,8+(20*64)
		call	PrintText
		
KeyWait:
		mvi	a,8
		call	SNSMAT
		ani	00000001
		jz	StartGame
		mvi	a,7
		call	SNSMAT
		ani	00010000b
		jz	ExitGame
		jmp	KeyWait
StartGame:
		mvi	a,00h		; 
		out	88h

		mvi	a,00010000b	;  VRAM - 0000h-3FFFh
					; 2
		out	84h
		mvi	a,00000110b	; PNT  VRAM - 1800h
		out	91h 
		mvi	a,00000000b	;PGT    2000h  VRAM ( )
		out	92h
		mvi	a,00001000b	;CT    0000h  VRAM ( )
		out	93h
		in	86h
		ori	00010000b
		out	86h

		di
		jmp	L4004

ExitGame:
		lxi	h,0
		shld	4000h
		pchl

PrintText:
		mov	a,m
		ora	a
		rz
		stax	d
		inx	h
		inx	d
		jmp	PrintText

		jmp	L4004


;   CT
;WRTVRM:
;L004D:
;		mov	m,a
;		ret

;   CT
FILVRM:
L0056:
		push	h
		push	psw
		rrc
		rrc
		rrc
		rrc

		call	24B9h
;		push	d
;		mov	d,a
;FILVRMLoop:
;		mov	m,d
;		inx	h
;		dcx	b
;		mov	a,c
;		ora	b
;		jnz	FILVRMLoop
;		pop	d

		pop	psw
		pop	h
		ret

;   CT
LDIRVM:
L005C:
;		xchg
;		push	h
;LDIRVMLoop:	ldax	d
;		mov	m,a
;		inx	h
;		inx	d
;		dcx	b
;		mov	a,c
;		ora	b
;		jnz	LDIRVMLoop
;		pop	h

		push	d
		call	005Ch
		xchg
		pop	h
		ret

WRTPSG:
L0093:
		push	psw
		out	15h
		mov	a, e
		out	14h
		pop	psw
		ret

SNSMAT:
		push    b
		ani     0Fh
		mov     b, a
		in      82h
		ani     0F0h
		ora     b
		out     82h
		in      81h
		pop     b
		ret

GTSTCK:
L00D5:
		dcr     a
		jm      loc_1BD
		in      8Ch
		jz      loc_1B1
		in      8Dh
loc_1B1:
		lxi     h, JoyDir
		cma
loc_1B5:
		ani     00001111b
		mov     e, a
		mvi     d, 0
		dad     d
		mov     a, m
		ret
loc_1BD:
		mvi     a, 8
		call    SNSMAT
		rrc
		rrc
		rrc
		rrc
		lxi     h, KeybDir
		jmp     loc_1B5
KeybDir:
		.db    0,   3,   5,   4
		.db    1,   2,   0,   3
		.db    7,   0,   6,   5
		.db    8,   1,   7,   0
JoyDir:
		.db    0,   5,   1,   0
		.db    3,   4,   2,   3
		.db    7,   6,   8,   7
		.db    0,   5,   1,   0


GTTRIG:
L00D8:
		dcr     a
		jm      loc_244B
		push    psw
		cpi     2
		in      8Dh
		jnc     loc_243C
		in      8Ch
loc_243C:
		mov     b, a
		pop     psw
		ani     1
		mvi     a, 10h
		jz      loc_2446
		rlc
loc_2446:
		ana     b
		rz
		mvi     a, 1
		ret
loc_244B:
		mvi     a, 8
		call    SNSMAT
		cma
		ani     1
		rz
		mvi	a,0FFh
		ret

Letterc:	.db 0,0,90h,90h,90h,90h,0F8h,8

Letterj:	.db 01010000b
		.db 00100000b
		.db 10001000b
		.db 10011000b
		.db 10101000b
		.db 11001000b
		.db 10001000b
		.db 00000000b

Text1:	.db "COLOR BALL",0
Text2:	.db 0F7h,0C5h,0D2h,0D3h,0C9h,0D1h,' ',0C4h,0CCh,0D1h,' ',0F0h,0EBh,"8000",0
Text3:	.db 0E1h,0CCh,0C5h,0CBh,0D3h,0C1h,0CEh,0C4h,0D2h,' ',0F4h,0C9h,0CDh,0CFh,0DBh,0C5h,0CEh,0CBh,0CFh,0
Text4:	.db 0E9h,0D7h,0C1h,0CEh,' ',0E7h,0CFh,0D2h,0CFh,0C4h,0C5h,0C3h,0CBh,0C9h,0CAh,0
Text5:	.db "2008",0
Text6:	.db 0EEh,0C1h,0D6h,0CDh,0C9h,0D4h,0C5h,' ',0F0h,0F2h,0EFh,0E2h,0E5h,0ECh,' ',0C4h,0CCh,0D1h,' ',0D3h,0D4h,0C1h,0D2h,0D4h,0C1h,0
Text7:	.db 0EEh,0C1h,0D6h,0CDh,0C9h,0D4h,0C5h,' ',0F3h,0F4h,0EFh,0F0h,' ',0C4h,0CCh,0D1h,' ',0D7h,0D9h,0C8h,0CFh,0C4h,0C1h,0
